<?php
namespace Reports\Controller;

use Cake\Core\Configure;
use Cake\Network\Session;
use Reports\Controller\AppController;
use Cake\Event\Event;

/**
 * Occurrences Controller
 *
 * @property \Reports\Model\Table\OccurrencesTable $Occurrences
 *
 * @method \Reports\Model\Entity\Occurrence[]|\Cake\Datasource\ResultSetInterface paginate($object = null, array $settings = [])
 */
class OccurrencesController extends AppController
{
    public $helpers = ['Dompdf.Dompdf'];

    public function initialize()
    {
        parent::initialize(); // TODO: Change the autogenerated stub
        $this->loadComponent('Search.Prg', [
            'actions' => ['index']
        ]);

        $this->loadComponent('Reports.PrintReport');
    }

    public function beforeRender(Event $event)
    {
        parent::beforeRender($event);
        $this->viewBuilder()->setHelpers(['Materialize.Form']);
    }
    /**
     * Index method
     *
     * @return \Cake\Http\Response|void
     */
    public function index()
    {
        if ($this->request->is(['patch'])) {
            $this->requestPrintOccurrences($this->request->getQueryParams());
        }

        $occurrences = $this->Occurrences->find('all', [
            'contain' => ['Users', 'Sectors', 'Status', 'Categories']
        ])
            ->find('search', ['search' => $this->request->getQueryParams()])
            ->orderDesc('Occurrences.created');

        $occurrences = $this->paginate($occurrences);
        $sectors = $this->Occurrences->Sectors->find('list')->orderAsc('name');
        $categories = $this->Occurrences->Categories->find('list')->orderAsc('name');
        $status = $this->Occurrences->Status->find('list')->orderAsc('name');

        $this->set(compact('occurrences', 'sectors', 'categories', 'status'));

        $occurrence = $this->Occurrences->newEntity();
        $occurrence = $this->Occurrences->patchEntity($occurrence, $this->request->getQueryParams());
        $occurrence->from = $this->request->getQuery('from');
        $occurrence->to = $this->request->getQuery('to');

        $this->set('occurrence', $occurrence);
        $this->set('sectors_query', $this->request->getQuery('sector_id'));
        $this->set('categories_query', $this->request->getQuery('category_id'));
        $this->set('status_query', $this->request->getQuery('status_id'));
    }

    private function requestPrintOccurrences($params)
    {
        $session = $this->request->getSession();
        $session->write('ReportsParams', $params);

        $this->redirect(['controller' => 'Pdf', 'action' => 'occurrences']);
    }
}
